"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var CircleQueue =
/*#__PURE__*/
function () {
  function CircleQueue(size) {
    (0, _classCallCheck2.default)(this, CircleQueue);
    this.data = new Array(size + 1);
    this.clear();
  }

  (0, _createClass2.default)(CircleQueue, [{
    key: "filter",
    value: function filter(f) {
      return this.data.filter(f);
    }
  }, {
    key: "clear",
    value: function clear() {
      this.start = 0;
      this.end = 0;
      this.data.fill(null);
    }
  }, {
    key: "enqueue",
    value: function enqueue(item) {
      this.data[this.end] = item;

      if ((this.end + 1) % this.data.length !== this.start) {
        this.end = (this.end + 1) % this.data.length;
      } else {
        this.end = (this.end + 1) % this.data.length;
        this.start = (this.start + 1) % this.data.length;
      }
    }
  }, {
    key: "size",
    value: function size() {
      return (this.end - this.start + this.data.length) % this.data.length;
    }
  }, {
    key: "dequeue",
    value: function dequeue() {
      var size = this.size();
      if (size < 1) throw new Error('没有元素');
      var item = this.data[this.start];
      this.start = (this.start + 1) % this.data.length;
      return item;
    }
  }, {
    key: "pop",
    value: function pop() {
      var size = this.size();
      if (size < 1) throw new Error('没有元素');
      var end = (this.end - 1 + this.data.length) % this.data.length;
      var item = this.data[end];
      this.end = end;
      this.data[end] = null;
      return item;
    }
  }]);
  return CircleQueue;
}();

var _default = CircleQueue;
exports.default = _default;