"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _util = require("./util");

var Headers = {
  'Content-Type': 'application/json;charset=utf-8',
  'Access-Control-Allow-Origin': '*'
};

var Handle =
/*#__PURE__*/
function () {
  function Handle(_ref) {
    var path = _ref.path,
        get = _ref.get,
        post = _ref.post,
        options = _ref.options;
    (0, _classCallCheck2.default)(this, Handle);
    this.path = path;

    if (get) {
      this.get = get.bind(this);
    }

    if (post) {
      this.post = post.bind(this);
    }

    if (options) {
      this.options = options.bind(this);
    }
  }

  (0, _createClass2.default)(Handle, [{
    key: "do",
    value: function _do(req, res, server) {
      var _this = this;

      switch (req.method) {
        case 'GET':
          return this.get(req, res, server);

        case 'OPTIONS':
          return this.options(req, res, server);

        case 'POST':
          Handle.receiveData(req).then(function (json) {
            req.data = json;

            _this.post(req, res, server);
          });
          break;

        case 'DELETE':
          this.delete(req, res, server);
          break;

        default:
          throw new Error("".concat(req.method, "\u6682\u4E0D\u652F\u6301"));
      }
    }
  }, {
    key: "get",
    value: function get(req, res) {}
  }, {
    key: "post",
    value: function post(req, res) {}
  }, {
    key: "options",
    value: function options(req, res) {}
  }, {
    key: "delete",
    value: function _delete(req, res) {}
    /**
     * 解析url参数
     * @param {*} req 
     */

  }], [{
    key: "parseQuery",
    value: function parseQuery(req) {
      return (0, _util.parseQueryString)(req && req.url);
    }
  }, {
    key: "receiveData",
    value: function receiveData(req) {
      return new Promise(function (resolve, reject) {
        var data = '';
        req.on('data', function (chunk) {
          data += chunk;
        });
        req.on('end', function () {
          var json = JSON.parse(data);
          resolve(json);
        });
      });
    }
  }, {
    key: "setHeaders",
    value: function setHeaders(res) {
      Object.keys(Headers).forEach(function (k) {
        res.setHeader(k, Headers[k]);
      });
    }
    /**
     * 发送json返回
     * @param {*} res 
     * @param {*} data 
     */

  }, {
    key: "json",
    value: function json(data, res) {
      Handle.setHeaders(res);
      res.write(JSON.stringify(data));
      res.end();
    }
  }, {
    key: "success",
    value: function success(data, res) {
      return Handle.json({
        success: true,
        data: data
      }, res);
    }
  }, {
    key: "fail",
    value: function fail(data, res) {
      console.error(data);
      return Handle.json({
        succes: false,
        data: data
      }, res);
    }
  }]);
  return Handle;
}();

var _default = Handle;
exports.default = _default;