"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _http = _interopRequireDefault(require("http"));

var _internalIp = _interopRequireDefault(require("internal-ip"));

var _domain = _interopRequireDefault(require("@alipay/domain"));

var _circlequeue = _interopRequireDefault(require("./circlequeue"));

var _process = _interopRequireDefault(require("process"));

var _path = _interopRequireDefault(require("path"));

var _util = require("./util");

var HServer =
/*#__PURE__*/
function () {
  function HServer(fileclient, folder) {
    var _this = this;

    var port = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 8003;
    var host = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '0.0.0.0';
    (0, _classCallCheck2.default)(this, HServer);
    this.folder = folder;
    this.fileclient = fileclient;
    this.hserver = _http.default.createServer(this.handler.bind(this));
    var pluginOpts = {
      ip: (0, _internalIp.default)(),
      type: 'alipay'
    };
    (0, _domain.default)(pluginOpts).then(function (domainInfo) {
      try {
        // set('domainServiceDomainInfo', domainInfo);
        _this.hserver.listen(port, host);

        var fpath = _path.default.join(_process.default.cwd(), 'magic.json');

        var conf = (0, _util.readJSON)(fpath);
        conf.host = pluginOpts.ip;
        conf.port = port;
        (0, _util.writeJSON)(fpath, conf);
        console.log("read data from ".concat(folder, "\nStart Magic Server http://").concat(domainInfo.domain, ":").concat(port, ", http://").concat(pluginOpts.ip, ":").concat(port));
      } catch (err) {
        console.error("failed to apply ".concat(pluginOpts.type, " domain, try later, ERROR:ERROR ").concat(err));
      }
    }, function (err) {
      _this.hserver.listen(port, '0.0.0.0');

      console.info("Start Magic Server http://".concat(pluginOpts.ip, ":").concat(port));
    });
    this.handlers = [];
    this.requests = new _circlequeue.default(20);
  }

  (0, _createClass2.default)(HServer, [{
    key: "addHandler",
    value: function addHandler(handle) {
      this.handlers.push(handle);
    }
  }, {
    key: "addHandlers",
    value: function addHandlers(handles) {
      var _this2 = this;

      handles.forEach(function (h) {
        return _this2.addHandler(h);
      });
    }
  }, {
    key: "handler",
    value: function handler(req, res) {
      var idx = req.url.indexOf('?');
      var path = idx < 0 ? req.url : req.url.substring(0, idx); // const params = parseQueryString(req.url)

      console.info("request ".concat(path, ", method:").concat(req.method));
      var hs = this.handlers.filter(function (h) {
        return h.path === path;
      });

      if (hs.length === 1) {
        hs[0].do(req, res, this.fileclient);
      } else {
        console.error("".concat(path, " is not found"));
      }
    }
  }]);
  return HServer;
}();

exports.default = HServer;