"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeJSON = exports.readJSON = exports.parseQueryString = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _jsonfile = _interopRequireDefault(require("jsonfile"));

var _fs = _interopRequireDefault(require("fs"));

var parseQueryString = function parseQueryString() {
  var search = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : location && location.search;
  if ((0, _typeof2.default)(search) !== (0, _typeof2.default)('')) throw new Error('param must be a string');
  if (search.length < 3) return {};
  var query = search.substring(search.indexOf('?') + 1);
  var reg = /([^=&#]+)=([^&#]*)/ig;
  var match = null;
  var result = {};

  while (match = reg.exec(query)) {
    result[decodeURIComponent(match[1])] = decodeURIComponent(match[2]);
  }

  return result;
};

exports.parseQueryString = parseQueryString;

var readJSON = function readJSON(path) {
  try {
    var data = _fs.default.readFileSync(path);

    return JSON.parse(data);
  } catch (e) {
    return {};
  }
};

exports.readJSON = readJSON;

var writeJSON = function writeJSON(path, json) {
  _jsonfile.default.writeFileSync(path, json, {
    spaces: 2,
    EOL: '\r\n'
  });
};

exports.writeJSON = writeJSON;